// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _AssertGenerator = require("./AssertGenerator");

var _AssertGenerator2 = _interopRequireDefault(_AssertGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var doctrine = require('doctrine');

var CommentConverter = function () {
    function CommentConverter() {
        _classCallCheck(this, CommentConverter);
    }

    _createClass(CommentConverter, null, [{
        key: "toAsserts",

        /**
         * Parse comment nodes which is provided by JavaScript parser like esprima, babylon
         * and return assertions code strings.
         * This is mutable function.
         * @param {Array<Object>} comment
         * @param {AssertGeneratorOptions} [options]
         * @returns {string[]}
         */
        value: function toAsserts(comment, options) {
            /*
             TODO: sloppy is not support
             It mean that optional param just ignored.
             */
            try {
                var commentData = doctrine.parse(comment.value, { unwrap: true });
                return _AssertGenerator2.default.createAsserts(commentData, options);
            } catch (error) {
                error.message = "jsdoc-to-assert: JSDoc Parse Error:\n" + error.message;
                throw error;
            }
        }
    }]);

    return CommentConverter;
}();

exports.default = CommentConverter;
module.exports = exports['default'];
//# sourceMappingURL=CommentConverter.js.map